import { Dispatch, MutableRefObject } from 'react';
import { Observable } from 'rxjs';
import { AuthActions } from './actionTypes';
import { AuthStorage } from './storage';
import { AuthTokens, RefreshTokenCall, CurryAuthApiFn, CurryAuthApiFnPromise } from './types';
export interface CallApiEffect<A> {
    callAuthApiPromise<O>(apiFn: CurryAuthApiFnPromise<A, O>, ...args: any[]): Promise<O>;
    callAuthApiObservable<O>(apiFn: CurryAuthApiFn<A, O>, ...args: any[]): Observable<O>;
    unsubscribe(): void;
}
export default function makeCallApiRx<A, R>(refreshTokenCall: RefreshTokenCall<A, R> | undefined, dispatch: Dispatch<AuthActions>, storage: AuthStorage<A, R>, tokenRef: MutableRefObject<AuthTokens<A, R> | null>, bootRef: MutableRefObject<boolean>, actionObservable: Observable<AuthActions>): CallApiEffect<A>;
