import { ChangeEvent, FormEvent } from 'react';
import { Observable } from 'rxjs';
import { AuthActionCreators, AuthUser } from './Auth';
import { CurryAuthApiFn, CurryAuthApiFnPromise } from './types';
export declare function useAuthState(): import("./Auth").AuthState;
export declare function useAuthActions<A = any, R = any, U = any, C = any>(): AuthActionCreators<A, R, U, C>;
export declare function useAuthCallObservable<A, O, FA extends any[]>(fn: CurryAuthApiFn<A, O, FA>): (...args: FA) => Observable<O>;
export declare function useAuthCallPromise<A, O, FA extends any[]>(fn: CurryAuthApiFnPromise<A, O, FA>): (...args: FA) => Promise<O>;
export declare function useAuthUser<U = any, A = any>(): AuthUser<U, A>;
interface ValueProp {
    value: string;
}
interface OnChangeProp {
    onChange(e: ChangeEvent<HTMLInputElement>): void;
}
export interface ShapeLoginResult {
    handleSubmit(e: FormEvent): void;
    login(): void;
    loginError: any;
    loginLoading: boolean;
}
export declare type LoginResult = ShapeLoginResult & Record<string, ValueProp & OnChangeProp>;
export declare function useLogin(credentialsConf?: string[]): LoginResult;
export {};
