import { ComponentType, ReactNode } from 'react';
import { RouteProps } from 'react-router-dom';
import { Location } from 'history';
export declare type AuthRouteProps<U = any> = {
    redirectTest?: null | ((user: U) => string | null | undefined | Location);
    redirectTo?: string | Location;
    spinner?: ReactNode;
    spinnerComponent?: ComponentType;
    rememberReferrer?: boolean;
} & RouteProps;
/**
 * Wrapper around `<Route />`, render given spinner or null while auth is loading
 * then ensure authenticated user otherwise render a `<Redirect />`.
 *
 */
export default function AuthRoute({ redirectTest: localRedirectTest, redirectTo: localRedirectTo, spinner: localSpinner, spinnerComponent: localSpinnerComponent, rememberReferrer: localRememberReferrer, ...rest }: AuthRouteProps): JSX.Element;
