import { ComponentType, ReactNode } from 'react';
import { RouteProps } from 'react-router-dom';
import { Location } from 'history';
import { Dictionary } from './types';
export declare type GuestRouteProps = {
    redirectTo?: string | Location<Dictionary>;
    redirectToReferrer?: boolean;
    spinner?: ReactNode;
    spinnerComponent?: ComponentType;
} & RouteProps;
/**
 * Wrapper around `<Route />`, render given spinner or null while auth is loading
 * then ensure guest (not authenticated) user otherwise render a `<Redirect />`.
 *
 */
export default function GuestRoute({ children, component, render, spinner: localSpinner, spinnerComponent: localSpinnerComponent, redirectTo: localRedirectTo, redirectToReferrer: localRedirectToReferrer, ...rest }: GuestRouteProps): JSX.Element;
